package sita;

import org.sanskritlibrary.catalogs.ApplicationState;
import javax.swing.DefaultListModel;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class AnnotationChooserDialog extends JDialog implements ListSelectionListener
{
    ApplicationState appstate;
    JList annotations;
    DefaultListModel annotationsModel = new DefaultListModel();
    JLabel instructions = null;
    JScrollPane annotationsScroller;
    int selectedAnnotation = -1;

    public AnnotationChooserDialog(ApplicationState appstate)
    {
        this.appstate = appstate;
        setLayout(null);
        setSize(400, 400);
        setModal(true);
        Utils.centerScreen(this);

        instructions = new JLabel("Click on the annotation that you want to view");
        instructions.setOpaque(true);
        instructions.setSize(300, 20);
        instructions.setLocation(0, 0);
        add(instructions);
        
        annotations = new JList(annotationsModel);
        annotations.addListSelectionListener(this);
        annotationsScroller = new JScrollPane(annotations);
        annotationsScroller.setSize(380, 340);
        annotationsScroller.setLocation((getSize().width - annotationsScroller.getSize().width - 6)/2, 20);
        add(annotationsScroller);
    }

    public void display()
    {
        annotationsModel.clear();
        int n = appstate.getNumAnnotations();
        for (int i=0; i<n; i++)
        {
            String s = String.format("%d. %s", i+1, appstate.getAnnotation(i).getComment());
            annotationsModel.add(i, s);
        }
        selectedAnnotation = -1;
        setVisible(true);
    }

    public void valueChanged(ListSelectionEvent e)
    {
        selectedAnnotation = annotations.getSelectedIndex();
        setVisible(false);
    }

    public int getAnnotation()
    {
        return selectedAnnotation;
    }
}
