/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package sita;

import org.sanskritlibrary.catalogs.ApplicationState;
import org.sanskritlibrary.catalogs.TextPoint;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import java.util.ArrayList;
import javax.swing.JPanel;
import javax.swing.JScrollBar;

/**
 *
 * @author ralph
 */
public class AnnotationPanel extends JPanel implements AdjustmentListener {

    private int lastHorizontalValue = 0;
    private int lastVerticalValue = 0;
    protected AnnotationCanvas ac;
    private JScrollBar hsb;
    protected JScrollBar vsb;
    protected ApplicationState appstate;

    public AnnotationPanel (ApplicationState appstate, int x, int y, int width, int height) {
        this.appstate = appstate;
        this.setBounds(x, y, width, height);

        // Instantiation
        hsb = new JScrollBar(JScrollBar.HORIZONTAL);
        vsb = new JScrollBar(JScrollBar.VERTICAL);
        ac = new AnnotationCanvas(appstate, x, y, width - vsb.getWidth(), height - hsb.getHeight());

        // Location
        this.setLayout(new BorderLayout());
        this.add(hsb, BorderLayout.SOUTH);
        this.add(vsb, BorderLayout.EAST);
        this.add(ac, BorderLayout.CENTER);

        // Configuration
        hsb.setMaximum(100);
        hsb.addAdjustmentListener(this);
        hsb.setSize(width, hsb.getSize().height);
        vsb.addAdjustmentListener(this);
        vsb.setSize(vsb.getSize().width, height);
    }

    public void setText(ArrayList<String> lines) {
        ac.setText(lines);
        vsb.setMaximum(lines.size());
        appstate.setTextLines(lines);
    }

    public void setPanelFont(Font font) {
        setFont(font);
        ac.setPanelFont(font);
    }

    public void setHighlightColor (Color c) {
        ac.setHighlightColor(c);
    }

    public int getLineCount () {

        return 0;       // TODO!
    }

    protected void setScroller (TextPoint tp) {
        vsb.setValue(tp.row);
        lastVerticalValue = tp.row;
    }

    /*
public static final int 	ADJUSTMENT_FIRST 	601
public static final int 	ADJUSTMENT_LAST 	601
public static final int 	ADJUSTMENT_VALUE_CHANGED 	601
public static final int 	BLOCK_DECREMENT 	3
public static final int 	BLOCK_INCREMENT 	4
public static final int 	TRACK 	5
public static final int 	UNIT_DECREMENT 	2
public static final int 	UNIT_INCREMENT 	1     */

    public void adjustmentValueChanged(AdjustmentEvent e) {
        int n = e.getValue();

        if (e.getSource() == hsb) {     // horizontal scroll
            hsb.setValue(n + 20);
        } else {
            ac.setCurrentTopLine(e.getValue());
        }
    }

    // Give focus programatically (instead of with a mouse click). This means that next mouse click will be recognized.
    public void giveFocus () {
        ac.setAllowMouseClick(true);
    }
}
