package sita;

import org.sanskritlibrary.catalogs.BookmarkInfo;
import java.awt.Canvas;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.SwingConstants;

public class BookmarkDialog extends JDialog implements ActionListener {
    private ArrayList<BookmarkInfo> bookmarks;
    private JFrame parent;
    private int selectedBookmark;
    private int maxwidth = 0;
    private int panelHeight;
    private int lineHeight;
    private int buttonWidth;
    private int sep;
    private JPanel panel;

    public BookmarkDialog (JFrame parent, ArrayList<BookmarkInfo> bookmarks) {
        super(parent);

//        qd();

        int x = 10;
        int y = 10;
        lineHeight = 20;
        int lineGap = 10;
        int textWidth = 200;
        buttonWidth = 45;
        sep = 10;

        this.parent = parent;
        this.bookmarks = bookmarks;
        
        setLayout(null);
        this.setModalityType(ModalityType.APPLICATION_MODAL);
        this.setBounds(0, 0, 400, 500);

        panel = new JPanel();
        panel.setLayout(null);
        int len = bookmarks.size();


        for (int i=0; i<len; i++) {
            BookmarkInfo bi = bookmarks.get(i);
            JButton button = new JButton();
            button.setText(">");
            button.setActionCommand(Integer.toString(i));
            button.setBounds(0, y, buttonWidth, lineHeight);
            button.addActionListener(this);
            panel.add(button);
            JLabel label =  new JLabel(bi.text);
            label.setBounds(buttonWidth + sep, y, textWidth, lineHeight);
            label.setOpaque(true);
            panel.add(label);
            y += lineHeight + lineGap;
        }

        panelHeight = y + lineHeight + lineGap + 30;

        panel.setBounds(0, 0, maxwidth, panelHeight);
        panel.setPreferredSize(new Dimension(400, panelHeight));
        JScrollPane scrollPane = new JScrollPane(panel);
        scrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
        scrollPane.setBounds(0, 0, 400, 400);
        this.add(scrollPane);
        Utils.centerScreen(this);
    }


    private void qd () {
        String[] a = new String[]
            {"ALPHA",
             "BRAVO",
             "CHARLIE",
             "DELTA",
             "ECHO",
             "FOXTROT",
             "GOLF",
             "HOTEL",
             "INDIA",
             "JULIE",
             "KILO",
             "LIMA",
             "MIKE",
             "NOVEMBER",
             "OSCAR",
             "PAPA",
             "QUEBEC",
             "ROMEO",
             "SIERRA",
             "TANGO",
             "UNIFORM",
             "VICTOR",
             "WHISKEY",
             "XRAY",
             "YANKEE",
             "ZULU"};

        int n = 0;
        for (String s : a) {
            n += s.length();
        }

        StringBuilder[] b = new StringBuilder[n];
        int j = 0;
        for (String s: a) {
            for (int i=0; i<s.length(); i++) {
                b[j++] = new StringBuilder(s);
            }
        }

        j = 0;
        for (String s : a) {
            for (int k = 1; k <= s.length(); k++) {
                StringBuilder sb = b[j++];
                int len = s.length() - k;
                if (len > 0) {
                    sb.replace(k, k + len, "_____________".substring(0, len));
                }
                sb.append(String.format(" (%c entered at time ", s.charAt(k-1)));
            }
        }

        for (int i=0; i<n; i++) {
            System.out.println(b[i].toString());
        }
    }

    @Override
    public void paint (Graphics g) {
        if (maxwidth == 0) {
            FontMetrics metrics = new FontMetrics(this.getFont()) {};
            int len = bookmarks.size();
            for (int i=0; i<len; i++) {
                BookmarkInfo bi = bookmarks.get(i);
                int width = (int)metrics.getStringBounds(bi.text, g).getWidth();
                if (width > maxwidth) {
                    maxwidth = width;
                }
            }
            panel.setSize(maxwidth + buttonWidth + sep, panelHeight);
            panel.setPreferredSize(new Dimension(maxwidth + buttonWidth + sep, panelHeight));
            for (Component c : panel.getComponents()) {
                if (c instanceof JLabel) {
                    Dimension d = c.getSize();
                    c.setSize(maxwidth, (int)d.getHeight());
                }
            }
        }
        super.paint(g);
    }

    public void actionPerformed(ActionEvent e) {
        selectedBookmark = Integer.parseInt(e.getActionCommand());
        setVisible(false);
    }

    public int getBookmarkOffset() {
        if (bookmarks.size() > 0 && selectedBookmark < bookmarks.size()) {
            return bookmarks.get(selectedBookmark).offset;
        } else {
            return 0;
        }

    }

}
