package sita;

import org.sanskritlibrary.catalogs.ApplicationState;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class VerifyModificationDialog extends JDialog implements ActionListener
{
    ApplicationState appstate;
    JButton modifyAnnotation;
    JButton newAnnotation;
    JLabel description;
    boolean createNewAnnotation = false;

    public VerifyModificationDialog(ApplicationState appstate)
    {
        this.appstate = appstate;
        setLayout(new BorderLayout());
        setModal(true);   // for Ubuntu
        setBounds(0, 0, 500, 100);
        description = new JLabel("You are reviewing annotations that have already been made. What do you want to do?");
        add(description, BorderLayout.CENTER);
        JPanel buttonPanel = new JPanel();
        newAnnotation = new JButton("Create a new annotation");
        newAnnotation.addActionListener(this);
        newAnnotation.setActionCommand("new");

        modifyAnnotation = new JButton("Modify this annotation");
        modifyAnnotation.addActionListener(this);
        modifyAnnotation.setActionCommand("modify");
        getRootPane().setDefaultButton(modifyAnnotation);

        buttonPanel.setLayout(new FlowLayout());
        buttonPanel.add(newAnnotation);
        buttonPanel.add(modifyAnnotation);
        add(buttonPanel, BorderLayout.SOUTH);
        Utils.centerScreen(this);
        Utils.setEscapeKeyListener(this);
    }

    public void display()
    {
        createNewAnnotation = false;
        setVisible(true);
    }

    public boolean getCreateNewAnnotation()
    {
        return createNewAnnotation;
    }

    public void actionPerformed(ActionEvent e)
    {
        if (e.getActionCommand().equals("new"))
        {
            createNewAnnotation = true;
        }
        else if (e.getActionCommand().equals("modify"))
        {
            appstate.setAllowModification(true);
        }
        setVisible(false);
    }
}
